Name: socks5
Version: 1.0r9
Release: 2
Group: Networking/Daemons
Summary: SOCKS 5.0 Server Daemon
Copyright: Copyright (c) 1995,1998 NEC Corporation.  Freely Distributable
Source0: http://wwww.socks.nec.com/12462347/%{name}-v%{version}.tar.gz
Source1: socks5.init
Source2: s5watchAG-beta-1.0-linux-2.0.tar.gz
Source3: socks5watch.init
Patch0: socks5-v1.0r9.patch1.txt
Patch1: socks5-v1.0r9.patch2.txt
Patch2: socks5-v1.0r9.patch3.txt
Patch3: socks5-v1.0r9.patch4.txt
Buildroot: /var/tmp/socks5-root
Packager: Henri Gomez <gomez@slib.fr>, Aron Griffis <agriffis@css.tayloru.edu>

%package clients
Summary: Network applications written to use NWSL SOCKS 5.0.
Group: Networking

%package devel
Summary: SOCKS 5.0 header file and library
Group: Development/Libraries

%description
This is NWSL (previously CSTC) version 5.0 of SOCKS, a package that
allows Unix hosts behind a firewall to gain full access to the
internet without requiring direct IP reachability.  It does require a
SOCKS server program being run on a host that can communicate directly
to hosts behind the firewall as well as hosts on the Internet at
large.  It is based on the original SOCKS written by David Koblas
<koblas@netcom.com> and the work of the AFT working group of the IETF.

%description clients
Client programs such as ping, traceroute, ftp, finger, whois, archie, and 
telnet that use SOCKS 5.0.  Also includes a dynamic link library and script 
that allows you to "socksify" programs that don't normally use SOCKS.

%description devel
This is the header file and library required to develop for NWSL 
(previously CSTC) version 5.0 of SOCKS.

%ifarch i386

%package s5watch
Summary: SOCKS 5.0 Server Daemon with s5watch support
Group: Networking/Daemons

%package s5watch-devel
Summary: SOCKS 5.0 header files and libraries with s5watch support
Group: Development/Libraries

%description s5watch
This is NWSL (previously CSTC) version 5.0 of SOCKS, a package that
allows Unix hosts behind a firewall to gain full access to the
internet without requiring direct IP reachability.  It does require a
SOCKS server program being run on a host that can communicate directly
to hosts behind the firewall as well as hosts on the Internet at
large.  It is based on the original SOCKS written by David Koblas
<koblas@netcom.com> and the work of the AFT working group of the IETF.

This version includes socks5watcher monitoring capability, which is
redistributable for non-commericial purposes only.

%description s5watch-devel
This is the header file and library required to develop for NWSL 
(previously CSTC) version 5.0 of SOCKS, including s5watch support.

%endif

%changelog
* Tue Apr 27 1999 Gomez Henri <gomez@slib.fr>

  * added child process and runaway process patches

* Wed Mar 31 1999 Gomez Henri <gomez@slib.fr>
  
   * added runsocks and udp close socket patches

* Thu Mar 11 1999 Gomez Henri <gomez@slib.fr>

   * Updated to 1.0r9
   * username/passwd eof fix
   * changed threading model
   * added SOCKS5_V4SUPPORT
   * runsocks.in fix <nobbi@cheerful.com>
   * Makefile.in install-sh bugs <eychenne@info.enserb.u-bordeaux.fr>
   * removed old MONITOR code
   * fixed 'make clean' target
   * sendmsg/recvmsg in headers generate warnings <michael@bizsystems.com>
   * modified ftp client so commands are not split into
     two packets.  some packet filtering firewalls will
     block connection when sent as two packets.
   * added doc to socks5.conf.5 about SOCKS5_REVERSEMAP
   * moved s5fakehost file from ~/.s5fakehost to /tmp/.s5fakehost.uid
   * dlopen relative paths do not work on FreeBSD <andre.albsmeier@mchp.siemens.de>
   * moved dlopen relative path to configure


* Thu Nov 19 1998 Henri Gomez  <nri@mail.dotcom.fr>

    Updated to 1.0r8 
    used the excellent spec file for 1.0r7 file from Aron Griffis <agriffis@css.tayloru.edu>
 
Fri Nov 13 10:18:06 CST 1998
        * updated setpgrp configure test
        * added SOCKS5_NOREVERSEMAP to config file parsing
          - config files with many IP addrs will load faster
        * pass dlopen() relative paths

Thu Nov 12 10:46:04 CST 1998
        * changed rresvport() wrapper -- like bind() wrapper
        * moved faked host table from memory to file
          - fixes Netscape Communicator 4.5 problem.
        * moved 'getpwuid()' in lsEffUser to fix FreeBSD bug.

Tue Nov  3 17:58:02 CST 1998
        * added test/handling for sendmsg/(recvmsg)

Tue Oct 27 12:44:44 CST 1998
        * added configure test for setpgrp

Tue Oct 20 11:58:41 CDT 1998
        * added blurb in socks5.conf.5 about proper configurations.

Wed Oct 14 09:16:16 CDT 1998
        * removed files with only internal code, related cleanup.

Fri Oct  9 09:09:42 CDT 1998 eychenne@col.bsf.alcatel.fr
        * changed bad #ifdef label in lib/log.c

Mon Oct  5 16:45:59 CDT 1998
        * added "round robin DNS" support (ftp-data).
        * changed SOCKS5_TIMEOUT & SOCKS5_UDPPORTRANGE
          - now can be set from /etc/socks5.conf
        * changed UDP recvfrom

Thu Oct  1 13:16:35 CDT 1998
        * changed Makefile.in clients.install target so
          libsocks5.a is not installed

* Mon Nov 16 1998 Aron Griffis <agriffis@css.tayloru.edu>
- built non-threaded version on sparc; the threaded version wants
  SIGUNUSED which isn't available
- s5watch stuff is now only built on i386

* Thu Nov 12 1998 Aron Griffis <agriffis@css.tayloru.edu>
- built both s5watch and normal packages from single source rpm

* Wed Nov 11 1998 Aron Griffis <agriffis@css.tayloru.edu>
- spec cleanup and buildrooted
- base package now contains socks daemon, modeled after bind rpms
- fixed init scripts to use chkconfig
- removed notes that were echoing on install; they were unnecessary
  and had the potential to cause problems with automated installations

* Wed Oct 21 1998 Henri Gomez  <nri@mail.dotcom.fr>

    Updated to 1.0r7

* Wed Jul 22 1998 Daniel Deimert <d1dd@dtek.chalmers.se>

    Updated to 1.0r6

* Mon Jul 13 1998 Daniel Deimert <d1dd@dtek.chalmers.se>

    Added Patches for RedHat 5.1

%prep 
%setup -n %{name}-v%{version} -a 2
%patch0 
%patch1
%patch2
%patch3

%build
# Ideally, we'd just build the threaded version on all platforms, but
# then it wants to use the signal SIGUNUSED, and this isn't available
# on sparc.  Also, the s5watch stuff is only available for i386.

if [ $RPM_ARCH = i386 ]; then
    ./configure --prefix=/usr \
	--with-srvpidfile=/var/run/socks5.pid \
	--with-libconffile=/etc/libsocks5.conf \
	--with-srvconffile=/etc/socks5.conf \
	--with-threads --with-monitor=`pwd`/s5watch
    make server
    mv server/socks5 server/socks5-s5watch
    make distclean
    ./configure --prefix=/usr \
	--with-srvpidfile=/var/run/socks5.pid \
	--with-libconffile=/etc/libsocks5.conf \
	--with-srvconffile=/etc/socks5.conf \
	--with-threads
    make
else
    ./configure --prefix=/usr \
	--with-srvpidfile=/var/run/socks5.pid \
	--with-libconffile=/etc/libsocks5.conf \
	--with-srvconffile=/etc/socks5.conf
    make
fi

%install
rm -rf $RPM_BUILD_ROOT
sourcedir=`pwd`

# "make install" creates all the necessary directories
make install prefix=$RPM_BUILD_ROOT/usr
cd $RPM_BUILD_ROOT/usr/bin
# We prefer the s5 prefix; it conflicts less
mv rarchie s5archie
mv rfinger s5finger
mv rftp s5ftp
mv rping s5ping
mv rtelnet s5telnet
mv rtraceroute s5traceroute
mv rwhois s5whois
# We restore the permissions on the clients in the %files section; 
# if they're 111 here then cpio won't be able to read them to build 
# the rpm.
chmod 511 s5*
# Move the daemon to the sbin directory
mkdir ../sbin
mv socks5 stopsocks ../sbin
# Install the init script
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m 755 $RPM_SOURCE_DIR/socks5.init \
    $RPM_BUILD_ROOT/etc/rc.d/init.d/socks5
# Default config file for the clients; no default for the daemon
echo "socks5 - - - - -" > $RPM_BUILD_ROOT/etc/libsocks5.conf

# Now install s5watch
if [ $RPM_ARCH = i386 ]; then
    cd $sourcedir
    mkdir -p $RPM_BUILD_ROOT/usr/include/s5watch
    mkdir -p $RPM_BUILD_ROOT/usr/{man/man1,sbin,lib}
    # Install the s5watch version of the socks daemon
    install -m 755 server/socks5-s5watch $RPM_BUILD_ROOT/usr/sbin
    # Same technique as above for building the rpm with proper permissions
    cd s5watch
    install -m 511 stopwatch $RPM_BUILD_ROOT/usr/sbin
    install -m 511 socks5watchAG $RPM_BUILD_ROOT/usr/sbin
    install -m 644 stopwatch.1 $RPM_BUILD_ROOT/usr/man/man1
    install -m 644 socks5watch.1 $RPM_BUILD_ROOT/usr/man/man1
    install -m 644 include/* $RPM_BUILD_ROOT/usr/include/s5watch
    install -m 755 lib/libmon.a $RPM_BUILD_ROOT/usr/lib
    # Install the init script
    install -m 755 $RPM_SOURCE_DIR/socks5watch.init \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/socks5watch
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc ChangeLog Copyright README doc examples patches
%doc /usr/man/man1/stopsocks.1
%doc /usr/man/man1/socks5.1
%doc /usr/man/man5/socks5.conf.5
%doc /usr/man/man5/socks5.passwd.5
/usr/sbin/stopsocks
/usr/sbin/socks5
# This is marked %config so it'll be preserved if customizations are
# made and an upgrade is done.
%config /etc/rc.d/init.d/socks5

%files clients
%defattr(-,root,root)
%config /etc/libsocks5.conf
%doc /usr/man/man1/socks5_clients.1
%doc /usr/man/man1/runsocks.1
%doc /usr/man/man5/libsocks5.conf.5
/usr/lib/libsocks5_sh.so
/usr/bin/runsocks
%attr(111,root,root) /usr/bin/s5*

%files devel
%defattr(-,root,root)
%doc test
/usr/lib/libsocks5.a
/usr/include/socks.h

%post
chkconfig --add socks5

%preun
if [ $1 = 0 ]; then
    chkconfig --del socks5
fi

%ifarch i386

%files s5watch
%defattr(-,root,root)
%doc ChangeLog Copyright README doc examples patches
%doc s5watch/Copyright s5watch/README
%doc /usr/man/man1/stopsocks.1
%doc /usr/man/man1/socks5.1
%doc /usr/man/man5/socks5.conf.5
%doc /usr/man/man5/socks5.passwd.5
%doc /usr/man/man1/socks5watch.1
%doc /usr/man/man1/stopwatch.1
/usr/sbin/stopsocks
/usr/sbin/socks5
%attr(111,root,root) /usr/sbin/socks5watchAG
%attr(111,root,root) /usr/sbin/stopwatch
# These are marked %config so they'll be preserved if customizations are
# made and an upgrade is done.
%config /etc/rc.d/init.d/socks5
%config /etc/rc.d/init.d/socks5watch

%files s5watch-devel
%defattr(-,root,root)
%doc test
/usr/lib/libsocks5.a
/usr/include/socks.h
/usr/lib/libmon.a
/usr/include/s5watch

%post s5watch
ln -s socks5-s5watch /usr/sbin/socks5
chkconfig --add socks5
chkconfig --add socks5watch

%preun s5watch
if [ $1 = 0 ]; then
    [ -L /usr/sbin/socks5 ] && rm /usr/sbin/socks5
    chkconfig --del socks5
    chkconfig --del socks5watch
fi

%endif
